Core - Task # 53514

Epic # 55070 (Accepted): Workpackages

Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)

Epic # 55656 (Accepted): Optimize overall Extbase performance
Story # 55168 (Accepted): Optimize Extbase generic persistence

Status: Resolved Priority: Must have
Author: Nico de Haen Category: Extbase
Created: 2013-11-11 Assigned To: Nico de Haen
Updated: 2014-02-19 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: medium

Sprint Focus:

Subject: Extbase: DataMapper causes redundant queries

Description

The thawProperties method of the DataMapper does not check the identity map before retrieving the property value with
fetchRelated. This results in redundant queries on the same table with the same addWhere. For example SELECT

tx_foo_domain_model_bar.* FROM tx_foo_domain_model_bar WHERE uid IN ('1")

Related issues:
related to Core - Bug # 56442: Invalid FileReference used

related to Core - Task # 55167: Extbase: avoid parseQuery() / buildQuery() to...

Resolved
Resolved

2014-02-28
2014-03-20

2014-03-20

Associated revisions

Revision faa6e8a6 - 2014-02-18 23:35 - Nico de Haen

[BUGFIX] Check identity map for existing objects

The DataMapper should check if an object is already in the identityMap
before calling fetchRelated, since otherwise the object will be retrieved
from the database again.

Resolves: #53514

Releases: 6.1,6.2

Change-Id: 124e262322f1f0ba3c346fa01c50fa9063866aef7
Reviewed-on: https:/review.typo3.org/25252

Reviewed-by: Nico de Haen
Reviewed-by: Fabien Udriot
Tested-by: Wouter Wolters
Reviewed-by: Steffen Miiller
Tested-by: Steffen Mller

History

#1 - 2013-11-11 00:46 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/25252
#2 - 2013-11-11 00:59 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#3 - 2013-11-11 01:02 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#4 - 2013-11-21 23:17 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/25252

#5 - 2014-01-14 23:37 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#6 - 2014-01-14 23:58 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#7 - 2014-01-15 00:07 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/25252

#8 - 2014-01-17 23:51 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#9 - 2014-01-18 00:04 - Nico de Haen
- File ztest.zip added

Here is a small demo extension to test the gerrit patch.

Father has a n:1 relation to child1. If there are 2 (or more) fathers with a relation to child with uid 1 it will result in 2 (or more) identical queries

SELECT tx_ztest_domain_model_child1.* FROM tx_ztest_domain_model_child1 WHERE tx_ztest_domain_model_child1.uid IN ('1")
If there are 2 (or more) fathers with a relation to child with uid 1 it will result in a 2 (or more) identical queries

SELECT tx_ztest domain_model_child1.* FROM tx_ztest_domain_model_child1 WHERE tx_ztest_domain_model_child1.uid IN ('0")

#10 - 2014-01-18 01:52 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#11 - 2014-01-20 15:21 - Felix Oertel
- Parent task set to #55168

#12 - 2014-01-20 15:22 - Felix Oertel

- Assigned To set to Nico de Haen

#13 - 2014-01-20 19:16 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/25252

#14 - 2014-02-14 18:57 - Ernesto Baschny
- Project changed from Extbase MVC Framework to Core
- Category deleted (Extbase: Generic Persistence)

#15 - 2014-02-14 18:57 - Ernesto Baschny
- Category set to Extbase

- TYPOS3 Version set to 6.2

#16 - 2014-02-14 19:26 - Ernesto Baschny

- Subject changed from DataMapper causes redundant queries to Extbase: DataMapper causes redundant queries

#17 - 2014-02-19 00:30 - Nico de Haen
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:faa6e8a6a38698a814e64f6f2276f4afd415c485.

Files
ztest.zip 659.7 kB 2014-01-18 Nico de Haen
